(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["AxiosMockAdapter"] = factory();
	else
		root["AxiosMockAdapter"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var utils = __webpack_require__(1);

	var verbs = ['get', 'post', 'head', 'delete', 'patch', 'put'];

	function adapter() {
	  return function(resolve, reject, config) {
	    var url = config.url.slice(config.baseURL ? config.baseURL.length : 0);
	    var handler = utils.findHandler(this.handlers, config.method, url);

	    if (handler) {
	      utils.purgeIfReplyOnce(this, handler);
	      var response = handler[1] instanceof Function
	        ? handler[1](config)
	        : handler.slice(1);

	      utils.settle(resolve, reject, {
	        status: response[0],
	        data: response[1],
	        headers: response[2],
	        config: config
	      }, this.delayResponse);
	    } else {
	      utils.settle(resolve, reject, {
	        status: 404,
	        config: config
	      }, this.delayResponse);
	    }
	  }.bind(this);
	}

	function reset() {
	  this.handlers = verbs.reduce(function(accumulator, verb) {
	    accumulator[verb] = [];
	    return accumulator;
	  }, {});
	  this.replyOnceHandlers = [];
	}

	function MockAdapter(axiosInstance, options) {
	  reset.call(this);

	  if (axiosInstance) {
	    this.axiosInstance = axiosInstance;
	    this.originalAdapter = axiosInstance.defaults.adapter;
	    this.delayResponse = options && options.delayResponse > 0
	      ? options.delayResponse
	      : null;
	    axiosInstance.defaults.adapter = adapter.call(this);
	  }
	}

	MockAdapter.prototype.adapter = adapter;

	MockAdapter.prototype.restore = function restore() {
	  if (this.axiosInstance) {
	    this.axiosInstance.defaults.adapter = this.originalAdapter;
	  }
	};

	MockAdapter.prototype.reset = reset;

	MockAdapter.prototype.onAny = function onAny(matcher) {
	  var _this = this;
	  return {
	    reply: function reply(code, response, headers) {
	      var handler = [matcher, code, response, headers];
	      verbs.forEach(function(verb) {
	        _this.handlers[verb].push(handler);
	      });
	      return _this;
	    },

	    replyOnce: function replyOnce(code, response, headers) {
	      var handler = [matcher, code, response, headers];
	      _this.replyOnceHandlers.push(handler);
	      verbs.forEach(function(verb) {
	        _this.handlers[verb].push(handler);
	      });
	      return _this;
	    }
	  };
	};

	verbs.forEach(function(method) {
	  var methodName = 'on' + method.charAt(0).toUpperCase() + method.slice(1);
	  MockAdapter.prototype[methodName] = function(matcher) {
	    var _this = this;
	    return {
	      reply: function reply(code, response, headers) {
	        var handler = [matcher, code, response, headers];
	        _this.handlers[method].push(handler);
	        return _this;
	      },

	      replyOnce: function replyOnce(code, response, headers) {
	        var handler = [matcher, code, response, headers];
	        _this.handlers[method].push(handler);
	        _this.replyOnceHandlers.push(handler);
	        return _this;
	      }
	    };
	  };
	});

	module.exports = MockAdapter;


/***/ },
/* 1 */
/***/ function(module, exports) {

	'use strict';

	function find(array, predicate) {
	  var length = array.length;
	  for (var i = 0; i < length; i++) {
	    var value = array[i];
	    if (predicate(value)) return value;
	  }
	}

	function findHandler(handlers, method, url) {
	  return find(handlers[method.toLowerCase()], function(handler) {
	    if (typeof handler[0] === 'string') {
	      return url === handler[0];
	    } else if (handler[0] instanceof RegExp) {
	      return handler[0].test(url);
	    }
	  });
	}

	function purgeIfReplyOnce(mock, handler) {
	  var index = mock.replyOnceHandlers.indexOf(handler);
	  if (index > -1) {
	    mock.replyOnceHandlers.splice(index, 1);

	    Object.keys(mock.handlers).forEach(function(key) {
	      index = mock.handlers[key].indexOf(handler);
	      if (index > -1) {
	        mock.handlers[key].splice(index, 1);
	      }
	    });
	  }
	}

	function settle(resolve, reject, response, delay) {
	  if (delay > 0) {
	    setTimeout(function() {
	      settle(resolve, reject, response);
	    }, delay);
	    return;
	  }

	  if (response.config && response.config.validateStatus) {
	    response.config.validateStatus(response.status)
	      ? resolve(response)
	      : reject(response);
	    return;
	  }

	  // Support for axios < 0.11
	  if (response.status >= 200 && response.status < 300) {
	    resolve(response);
	  } else {
	    reject(response);
	  }
	}

	module.exports = {
	  findHandler: findHandler,
	  purgeIfReplyOnce: purgeIfReplyOnce,
	  settle: settle
	};


/***/ }
/******/ ])
});
;